/*
 * ConversionWrapper.java
 *
 * Created on April 6, 2007, 9:29 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package net.sf.sql2java.common.conversion;

import net.sf.sql2java.common.resources.ResourceNaming;

/**
 *
 * @author dge2
 */
public class ConversionWrapper {
    private ConversionManager manager;
    
// -- Constructors ------------------------------------------------------------
    
    public ConversionWrapper(ConversionManager manager) {
        this.manager = manager;
    }
    
// -- Template Based Conversion Wrappers --------------------------------------
    
    public String convertToFullJavaFile(String templateId, Object resource) {
        // TODO : FIX THIS
        /*
        Template template = appManager.getTemplateManager().getTemplate(templateId);
        
        ResourceNaming rn = new ResourceNaming();
        rn.append(convertToPackage(templateId, resource));
        rn.append(convertToTemplateCamelcase(templateId, resource));
        
        return rn.getAsFilePath() + template.getTargetExtension();*/
        return null;
    }
    
    public String convertToFullJavaClass(String templateId, Object resource) {
        ResourceNaming rn = new ResourceNaming();
        rn.append(convertToPackage(templateId, resource));
        rn.append(convertToClass(templateId, resource));
        
        return rn.getAsClassPath();
    }
    
    /**
     * Create the package name for the given template and class
     *
     * The scripting environment holds our template manager. We can use it to get
     * our template by using the provided templateId. Once we have the template we
     * can create our package name by getting the basePackage from the manager and
     * concatinating the template's targetPackage. We also need to parse the result
     * because there might be a parameter inside the name.
     *
     * @param templateId    The id of the template we want to get from the manager
     *
     * @param resource 
     * @return a string containing the parsed package name.
     */
    public String convertToPackage(String templateId, Object resource) {
        // TODO : FIX THIS
        /*
        String result = "";
        
        Template template = appManager.getTemplateManager().getTemplate(templateId);
        
        result += appManager.getTemplateManager().getBasePackage();
        result += ".";
        result += template.getTargetPackage();
        
        ParameterizedString naming = new ParameterizedString(result);
        
        prepareNaming(naming, resource);
        
        return manager.convertJavaKeyword(naming.parse()).toLowerCase();*/
        return null;
    }
    
    public String convertToClass(String templateId, Object resource) {
        return convertToTemplateCamelcase(templateId, resource);
    }
    
    public String convertToFile(String templateId, Object resource) {
        // TODO : FIX THIS
        /*
        Template template = appManager.getTemplateManager().getTemplate(templateId);
        
        String result = convertToTemplateCamelcase(templateId, resource);
        
        return StringUtils.camelcase(result, false, true) + template.getTargetExtension();*/
        return null;
    }
    
    public String convertToJavaFile(String templateId, Object resource) {
        // TODO : FIX THIS
        /*
        Template template = appManager.getTemplateManager().getTemplate(templateId);
        
        String result = convertToTemplateCamelcase(templateId, resource);
        
        return StringUtils.camelcase(result, true, true) + template.getTargetExtension();*/
        return null;
    }
    
    public String convertToVariable(String templateId, Object resource) {
        return convertToVariable(convertToTemplateCamelcase(templateId, resource));
    }
    
// -- Object Based Conversion Wrappers ----------------------------------------
    
    public String convertToVariable(String input) {
        // TODO : FIX THIS
        //return StringUtils.camelcase(input, false, true);
        return "";
    }
    
    public String convertToClass(String input) {
        // TODO : FIX THIS
        //return StringUtils.camelcase(input, true, true);
        return "";
    }
    
    public String convertToSql(String input) {
        String result = "";
        String[] parts = input.split("\\.");
        
        boolean convert = false;
        for (String part : parts)
            if (isSqlKeyword(part))
                convert = true;

        int i = 0;
        for (String part : parts) {
            if (i++ > 0)
                result += ".";

            convert = isSqlKeyword(part);
            
            if (convert) result += "\"";
            result += part;
            if (convert) result += "\"";
        }
        
        return result;
    }
    
    public String convertToJava(String input) {
        return manager.convertJavaKeyword(input);
    }
    
    public boolean isJavaKeyword(String input) {
        return manager.isJavaKeyword(input);
    }
    
    public boolean isSqlKeyword(String input) {
        return manager.isSqlKeyword(input);
    }
    
    public String capitalize(String input) {
        return input.substring(0, 1).toUpperCase() + input.substring(1);
    }
    
    public String decapitalize(String input) {
        return input.substring(0, 1).toLowerCase() + input.substring(1);
    }
    
// -- Helpers -----------------------------------------------------------------
    
    private String convertToTemplateCamelcase(String templateId, Object resource) {
        // TODO : FIX THIS
        /*Template template = appManager.getTemplateManager().getTemplate(templateId);
        
        ParameterizedString naming = new ParameterizedString(template.getTargetFilename());
        
        prepareNaming(naming, resource);
        
        return naming.parse();*/
        return null;
    }
}
